
#include "JSVCatBot.h"
#include <Servo.h>

char data;
int currentangle;
int rcvangle;
boolean newData = false;
JSVCatBot ThisRobot;
int catDirection;
int calculatedAngle;
int calculatedSpeed;
byte commands[4] = {0x00,0x00,0x00,0x00};
byte prevCommands[4] = {0x01,0x01,0x01,0x01};
unsigned long StartTime;

/*
int recvIntWithEndMarker() {
 int ndx = 0;
 char endMarker = '\n';
 char rc;
 int oldrcvangle;
 int calc;
 oldrcvangle = rcvangle;
 rcvangle=0;
 ndx = 0;
 
 while (Serial.available() > 0) {
   rc = Serial.read();
  
   if (rc != endMarker) {
     ndx++;
     if (ndx <=3){
      calc = (int)rc-48;
      rcvangle = rcvangle*10 + calc;
     }
     if (ndx >= 4) {
      while (Serial.available() > 0) {
        rc = Serial.read();
      }
      Serial.println("too many digits, try maximum 3");
      rcvangle = oldrcvangle;
      return oldrcvangle;
     }
   }
   else {
    if (rcvangle > 180){
      Serial.println("rcv is bigger than 180, not accepted");
      rcvangle = oldrcvangle;
      return oldrcvangle;
    }
    else{
      return rcvangle;
    }
   }
 }
}
*/

void setup() {
  // put your setup code here, to run once:
  ThisRobot.BluetoothOpenConnection();
  Serial.println("Initialized");

  /*
  delay(2000);
  ThisRobot.control_motor(1,0,40);
  ThisRobot.control_motor(2,0,40);
  */
  //ThisRobot.control_motor(1,1,0);
  //ThisRobot.control_motor(2,1,0);
  ThisRobot.InitServos();
  /*
  delay(2000);
  ThisRobot.SetWheelServoAngle(60);
  head.write(180-60-17);
  delay(1000);
  ThisRobot.SetWheelServoAngle(81);
  head.write(180-81-17);
  delay(1000);
  ThisRobot.SetWheelServoAngle(102);
  head.write(180-102-17);
  delay(1000);
  ThisRobot.SetWheelServoAngle(81);
  head.write(180-81-17);
  delay(1000);
  ThisRobot.SetWheelServoAngle(81);
  */
  Serial.println("In the loop");
  StartTime = millis();
  
  
}



void loop() {
    if (millis() > (StartTime+1000)){ // stop robot if communication fails
            ThisRobot.SetWheelServoAngle(81);
            ThisRobot.SetHeadServoAngle(180-81-17);
            ThisRobot.CatSpeed(1,0);
            Serial.println("Robot stopped");
            StartTime = millis();
            //reset comms
            Serial.end();
            Serial.begin(115200);
    }
    if(Serial.available()==4){
      StartTime = millis(); // reset timer when communication works
      memcpy(prevCommands,commands,4);  //Storing the received commands  
      commands[0] = Serial.read();  //Direction
      commands[1] = Serial.read();  //Speed
      commands[2] = Serial.read();  //Angle
      commands[3] = Serial.read();  //Lights and buttons states
      /*
      Serial.println("received");
      Serial.print("Received :");
      Serial.print(commands[0]);  //Direction
      Serial.print(" , ");
      Serial.print(commands[1]);  //Speed
      Serial.print(" , ");
      Serial.print(commands[2]);   //Angle
      Serial.print(" , ");
      Serial.print(commands[3]);   //Lights and buttons states
      
      /*
       Since the last byte yields the servo's angle (between 0-180), it can never be 255. At times, the two
       previous commands pick up incorrect values for the speed and angle. Meaning that they get the direction
       correct 100% of the time but sometimes get 255 for the speed and 255 for the angle
      */
      if((commands[2]<=0xb4)&&((commands[0]<=0xf5)&&(commands[0]>=0xf1))){
        //Make sure that the command received involves controlling the car's motors (0xf1,0xf2,0xf3)
        if(commands[0] <= 0xf3){
          if(commands[0] == 0xf1){  //Check if the move forward command was received
            if(prevCommands[0] != 0xf1){  //Change pin state to move forward only if previous state was not move forward
              if(prevCommands[0] == 0xf2){// wait for robot to stop fist not to overcharge the L293
                ThisRobot.CatSpeed(1,0);
                delay(500);
              }
              catDirection = 1;
              //Serial.println("Updated direction FWD");
            } 
          }
          else if(commands[0] == 0xf2){  //Check if the move back command was received    
            if(prevCommands[0] != 0xf2){  //Change pin state to move back only if previous state was not move back
              if(prevCommands[0] == 0xf1){// wait for robot to stop fist not to overcharge the L293
                ThisRobot.CatSpeed(1,0);
                delay(500);
              }
              catDirection = 0;
              //Serial.println("Updated direction BWD");
            }
          }
          else{  //Check if the stop command was received   
            if(prevCommands[0] != 0xf3){  //Change pin state to stop only if previous state was not stop
                ThisRobot.CatSpeed(1,0);
              //Serial.println("Updated direction STP");
            }
          }
          //Change speed only if new speed is not equal to the previous speed
          if(prevCommands[1] != commands[1]){
            ThisRobot.CatSpeed(catDirection,commands[1]);
            //Serial.println("Updated speed");
          }         
          //Steer front wheels only if the new angle is not equal to the previous angle
          if(prevCommands[2] != commands[2]){
            ThisRobot.SetWheelServoAngle(commands[2]);
            ThisRobot.SetHeadServoAngle(180-commands[2]-17);
            //Serial.println("Updated angle");
          }        
        }
        else if(commands[0] == 0xf5){
          if(prevCommands[0] != 0xf5){
            //Stop everything
            ThisRobot.SetWheelServoAngle(81);
            ThisRobot.CatSpeed(1,0);
          }
        }
        else{
          //Here you put the code that will control the tilt pan (commands[0] == 0xf4)  
        }
        /*Check the front/back lights and other toggles  
        if(prevCommands[3] != commands[3]){
          //Serial.println(commands[3],BIN);
          //Change the light/button states
          //               _______________________________________________
          //command[3] =  |  0  |  0  |  0  |  0  |  0  |  0  |  0  |  0  |  binary
          //              |_____|_____|_____|_____|_____|_____|_____|_____|
          //Buttons ---->  Front  Back  Horn   A     B     C     D     E  
          //Front lights
          if((bitRead(prevCommands[3],7))!=(bitRead(commands[3],7))){
            if(bitRead(commands[3],7)){
              digitalWrite(pinFrontLights,HIGH);
            }
            else{
              digitalWrite(pinFrontLights,LOW);
            }
          }
          Back lights
          if((bitRead(prevCommands[3],6))!=(bitRead(commands[3],6))){
            if(bitRead(commands[3],6)){
              digitalWrite(pinBackLights,HIGH);
            }
            else{
              digitalWrite(pinBackLights,LOW);
            }
          }
          //Horn (using front lights to test)
          if((bitRead(prevCommands[3],5))!=(bitRead(commands[3],5))){
            if(bitRead(commands[3],5)){
              digitalWrite(pinFrontLights,HIGH);
            }
            else{
              digitalWrite(pinFrontLights,LOW);
            }
          }
        }
    */
      }
      else{
        //Resetting the Serial port (clearing the buffer) in case the bytes are not being read in correct order.
        Serial.end();
        Serial.begin(115200);
      }
    }
}

